/*
*Copyright©2023 National Fundamental Software of China Co., Ltd. 
*(National Engineering Research Center of Fundamental Software). 
*All Rights Reserved.
*
 * Author:     xiongwei <xiongwei@nfschina.com>
 *
 * Maintainer: xiongwei <xiongwei@nfschina.com>
 *
*This software is provided by the copyright holders - National Fundamental Software of China Co., Ltd. 
*(National Engineering Research Center of Fundamental Software). 
*The above copyright is protected by copyright laws in all countries andthe Universal Copyright Convention. 
*National Fundamental Software of China Co., Ltd. (National Engineering Research Center of Fundamental Software) 
*will reserve the right to take any necessary legal means against the unauthorized use of this software or any use that
*appears outside of National Fundamental Software of China Co., Ltd. ‘s 
*(National Engineering Research Center of Fundamental Software's) 
*intellectual property declaration.
*/

#ifndef SM_FPRO_H
#define SM_FPRO_H

#ifdef __cplusplus
extern "C" {
#endif
/**
 * @brief 设置文件为保护状态
 * 
 * @param path 文件路径
 * @return int 0: 成功, 其他: 失败
 */
int fpro_policy_add(char *path);

/**
 * @brief 移除文件的保护状态
 * 
 * @param path 文件路径
 * @return int 0: 成功, 其他: 失败
 */
int fpro_policy_remove(char *path);


/**
 * @brief 递归添加目录下文件至保护状态
 * 
 * @param path 
 * @return int 0: 成功, 其他: 失败
 */
int fpro_policy_add_by_dir(char *path);

/**
 * @brief 递归移除目录下文件的保护状态
 * 
 * @param path 目录路径
 * @return int 0: 成功, 其他: 失败
 */
int fpro_policy_remove_by_dir(char *path);

/**
 * @brief 获取所有被保护的文件路径
 * 
 * @param count 记录数量
 * @return char** NULL: 失败或记录不存在, 其他: 成功，配置信息数组
 */
char **fpro_read_all_data(int *count);

#ifdef __cplusplus
}
#endif

#endif // SM_FPRO_H
