#ifndef SM_PBLK_H
#define SM_PBLK_H
#define SM_DEVCTL_VM_PERM   0x89b4
#define VM_PATH_LEN 1024

#ifdef __cplusplus
extern "C" {
#endif

struct sm_devctl_vm
{
    char vm_path[VM_PATH_LEN];
    int perm;
};

enum pblk_perm
{
    PBLK_DISABLE,
    PBLK_ENABLE
};

int perm_setup(int ioctl_cmd, void *argp);

/**
 * @brief 将一个程序添加进程保护
 * 
 * @param path 二进制文件路径
 * @return 0: 成功, 1: 已存在, 其他: 失败
 */
int pblk_policy_add(char *path);

/**
 * @brief 将一个程序移除进程保护
 * 
 * @param path 二进制文件路径
 * @return 0: 成功, 1: 已存在, 其他: 失败
 */
int pblk_policy_remove(char *path);

/**
 * @brief 获取所有被保护进程的二进制路径
 * 
 * @param count 记录数量
 * @return char** NULL: 失败或记录不存在, 其他: 成功，配置信息数组
 */
char **pblk_read_all_data(int *count);


#ifdef __cplusplus
}
#endif



#endif // SM_PBLK_H