/*
*Copyright©2023 National Fundamental Software of China Co., Ltd. 
*(National Engineering Research Center of Fundamental Software). 
*All Rights Reserved.
*
 * Author:     xiongwei <xiongwei@nfschina.com>
 *
 * Maintainer: xiongwei <xiongwei@nfschina.com>
 *
*This software is provided by the copyright holders - National Fundamental Software of China Co., Ltd. 
*(National Engineering Research Center of Fundamental Software). 
*The above copyright is protected by copyright laws in all countries andthe Universal Copyright Convention. 
*National Fundamental Software of China Co., Ltd. (National Engineering Research Center of Fundamental Software) 
*will reserve the right to take any necessary legal means against the unauthorized use of this software or any use that
*appears outside of National Fundamental Software of China Co., Ltd. ‘s 
*(National Engineering Research Center of Fundamental Software's) 
*intellectual property declaration.
*/

#ifndef SM_PPRO_H
#define SM_PPRO_H

#ifdef __cplusplus
extern "C" {
#endif
/**
 * @brief 将一个程序添加进程保护
 * 
 * @param path 二进制文件路径
 * @return 0: 成功, 1: 已存在, 其他: 失败
 */
int ppro_policy_add(char *path);

/**
 * @brief 将一个程序移除进程保护
 * 
 * @param path 二进制文件路径
 * @return 0: 成功, 1: 已存在, 其他: 失败
 */
int ppro_policy_remove(char *path);

/**
 * @brief 获取所有被保护进程的二进制路径
 * 
 * @param count 记录数量
 * @return char** NULL: 失败或记录不存在, 其他: 成功，配置信息数组
 */
char** ppro_read_all_data(int *count);


#ifdef __cplusplus
}
#endif

#endif // SM_PPRO_H
